var global = Function("return this;")()
/*!
  * Ender: open module JavaScript framework (client-lib)
  * copyright Dustin Diaz & Jacob Thornton 2011 (@ded @fat)
  * http://ender.no.de
  * License MIT
  */
!function (context) {

  // a global object for node.js module compatiblity
  // ============================================

  context['global'] = context

  // Implements simple module system
  // losely based on CommonJS Modules spec v1.1.1
  // ============================================

  var modules = {}
    , old = context.$

  function require (identifier) {
    // modules can be required from ender's build system, or found on the window
    var module = modules[identifier] || window[identifier]
    if (!module) throw new Error("Requested module '" + identifier + "' has not been defined.")
    return module
  }

  function provide (name, what) {
    return (modules[name] = what)
  }

  context['provide'] = provide
  context['require'] = require

  function aug(o, o2) {
    for (var k in o2) k != 'noConflict' && k != '_VERSION' && (o[k] = o2[k])
    return o
  }

  function boosh(s, r, els) {
    // string || node || nodelist || window
    if (typeof s == 'string' || s.nodeName || (s.length && 'item' in s) || s == window) {
      els = ender._select(s, r)
      els.selector = s
    } else els = isFinite(s.length) ? s : [s]
    return aug(els, boosh)
  }

  function ender(s, r) {
    return boosh(s, r)
  }

  aug(ender, {
      _VERSION: '0.3.6'
    , fn: boosh // for easy compat to jQuery plugins
    , ender: function (o, chain) {
        aug(chain ? boosh : ender, o)
      }
    , _select: function (s, r) {
        return (r || document).querySelectorAll(s)
      }
  })

  aug(boosh, {
    forEach: function (fn, scope, i) {
      // opt out of native forEach so we can intentionally call our own scope
      // defaulting to the current item and be able to return self
      for (i = 0, l = this.length; i < l; ++i) i in this && fn.call(scope || this[i], this[i], i, this)
      // return self for chaining
      return this
    },
    $: ender // handy reference to self
  })

  ender.noConflict = function () {
    context.$ = old
    return this
  }

  if (typeof module !== 'undefined' && module.exports) module.exports = ender
  // use subscript notation as extern for Closure compilation
  context['ender'] = context['$'] = context['ender'] || ender

}(this);
// ender:tar-example/.lib/utils as tar-example/.lib/utils
(function (context) {
  
  var module = { exports: {} }, exports = module.exports
    , $ = require("ender")
    ;
  
  
  /*
   * tar-js
   * MIT (c) 2011 T. Jameson Little
   */
  
  (function () {
  	"use strict";
  
  	var lookup = [
  			'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H',
  			'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P',
  			'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X',
  			'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f',
  			'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n',
  			'o', 'p', 'q', 'r', 's', 't', 'u', 'v',
  			'w', 'x', 'y', 'z', '0', '1', '2', '3',
  			'4', '5', '6', '7', '8', '9', '+', '/'
  		];
  	function clean(length) {
  		var i, buffer = new Uint8Array(length);
  		for (i = 0; i < length; i += 1) {
  			buffer[i] = 0;
  		}
  		return buffer;
  	}
  
  	function extend(orig, length, addLength, multipleOf) {
  		var newSize = length + addLength,
  			buffer = clean((parseInt(newSize / multipleOf) + 1) * multipleOf);
  
  		buffer.set(orig);
  
  		return buffer;
  	}
  
  	function pad(num, bytes, base) {
  		num = num.toString(base || 8);
  		return "000000000000".substr(num.length + 12 - bytes) + num;
  	}	
  	
  	function stringToUint8 (input, out, offset) {
  		var i, length;
  
  		out = out || clean(input.length);
  
  		offset = offset || 0;
  		for (i = 0, length = input.length; i < length; i += 1) {
  			out[offset] = input.charCodeAt(i);
  			offset += 1;
  		}
  
  		return out;
  	}
  
  	function uint8ToBase64(uint8) {
  		var i,
  			extraBytes = uint8.length % 3, // if we have 1 byte left, pad 2 bytes
  			output = "",
  			temp, length;
  
  		function tripletToBase64 (num) {
  			return lookup[num >> 18 & 0x3F] + lookup[num >> 12 & 0x3F] + lookup[num >> 6 & 0x3F] + lookup[num & 0x3F];
  		};
  
  		// go through the array every three bytes, we'll deal with trailing stuff later
  		for (i = 0, length = uint8.length - extraBytes; i < length; i += 3) {
  			temp = (uint8[i] << 16) + (uint8[i + 1] << 8) + (uint8[i + 2]);
  			output += tripletToBase64(temp);
  		}
  
  		// this prevents an ERR_INVALID_URL in Chrome (Firefox okay)
  		switch (output.length % 4) {
  			case 1:
  				output += '=';
  				break;
  			case 2:
  				output += '==';
  				break;
  			default:
  				break;
  		}
  
  		return output;
  	}
  
  	module.exports.clean = clean;
  	module.exports.pad = pad;
  	module.exports.extend = extend;
  	module.exports.stringToUint8 = stringToUint8;
  	module.exports.uint8ToBase64 = uint8ToBase64;
  }());
  

  provide("tar-example/.lib/utils", module.exports);
  $.ender(module.exports);
}(global));

// ender:tar-example/.lib/header as tar-example/.lib/header
(function (context) {
  
  var module = { exports: {} }, exports = module.exports
    , $ = require("ender")
    ;
  
  
  /*
   * tar-js
   * MIT (c) 2011 T. Jameson Little
   */
  
  (function () {
  	"use strict";
  	
  /*
  struct posix_header {             // byte offset
  	char name[100];               //   0
  	char mode[8];                 // 100
  	char uid[8];                  // 108
  	char gid[8];                  // 116
  	char size[12];                // 124
  	char mtime[12];               // 136
  	char chksum[8];               // 148
  	char typeflag;                // 156
  	char linkname[100];           // 157
  	char magic[6];                // 257
  	char version[2];              // 263
  	char uname[32];               // 265
  	char gname[32];               // 297
  	char devmajor[8];             // 329
  	char devminor[8];             // 337
  	char prefix[155];             // 345
                                    // 500
  };
  */
  
  	var utils =  require('tar-example/.lib/utils'),
  		headerFormat;
  	
  	headerFormat = [
  		{
  			'field': 'fileName',
  			'length': 100
  		},
  		{
  			'field': 'fileMode',
  			'length': 8
  		},
  		{
  			'field': 'uid',
  			'length': 8
  		},
  		{
  			'field': 'gid',
  			'length': 8
  		},
  		{
  			'field': 'fileSize',
  			'length': 12
  		},
  		{
  			'field': 'mtime',
  			'length': 12
  		},
  		{
  			'field': 'checksum',
  			'length': 8
  		},
  		{
  			'field': 'type',
  			'length': 1
  		},
  		{
  			'field': 'linkName',
  			'length': 100
  		},
  		{
  			'field': 'ustar',
  			'length': 8
  		},
  		{
  			'field': 'owner',
  			'length': 32
  		},
  		{
  			'field': 'group',
  			'length': 32
  		},
  		{
  			'field': 'majorNumber',
  			'length': 8
  		},
  		{
  			'field': 'minorNumber',
  			'length': 8
  		},
  		{
  			'field': 'filenamePrefix',
  			'length': 155
  		},
  		{
  			'field': 'padding',
  			'length': 12
  		}
  	];
  
  	function formatHeader(data, cb) {
  		var buffer = utils.clean(512),
  			offset = 0;
  
  		headerFormat.forEach(function (value) {
  			var str = data[value.field] || "",
  				i, length;
  
  			for (i = 0, length = str.length; i < length; i += 1) {
  				buffer[offset] = str.charCodeAt(i);
  				offset += 1;
  			}
  
  			offset += value.length - i; // space it out with nulls
  		});
  
  		if (typeof cb === 'function') {
  			return cb(buffer, offset);
  		}
  		return buffer;
  	}
  	
  	module.exports.structure = headerFormat;
  	module.exports.format = formatHeader;
  }());
  

  provide("tar-example/.lib/header", module.exports);
  $.ender(module.exports);
}(global));

// ender:tar-example/.lib/tar as tar-example/.lib/tar
(function (context) {
  
  var module = { exports: {} }, exports = module.exports
    , $ = require("ender")
    ;
  
  
  /*
   * tar-js
   * MIT (c) 2011 T. Jameson Little
   */
  
  (function () {
  	"use strict";
  
  	var header =  require('tar-example/.lib/header'),
  		utils =  require('tar-example/.lib/utils'),
  		recordSize = 512,
  		blockSize;
  	
  	function Tar(recordsPerBlock) {
  		this.written = 0;
  		blockSize = (recordsPerBlock || 20) * recordSize;
  		this.out = utils.clean(blockSize);
  	}
  
  	Tar.prototype.append = function (filepath, input, opts, callback) {
  		var data,
  			checksum,
  			mode,
  			mtime,
  			uid,
  			gid,
  			headerArr;
  
  		if (typeof input === 'string') {
  			input = utils.stringToUint8(input);
  		} else if (input.constructor !== Uint8Array.prototype.constructor) {
  			throw 'Invalid input type. You gave me: ' + input.constructor.toString().match(/function\s*([$A-Za-z_][0-9A-Za-z_]*)\s*\(/)[1];
  		}
  
  		if (typeof opts === 'function') {
  			callback = opts;
  			opts = {};
  		}
  
  		opts = opts || {};
  
  		mode = opts.mode || parseInt('777', 8) & 0xfff;
  		mtime = opts.mtime || Math.floor(+new Date() / 1000);
  		uid = opts.uid || 0;
  		gid = opts.gid || 0;
  
  		data = {
  			fileName: filepath,
  			fileMode: utils.pad(mode, 7),
  			uid: utils.pad(uid, 7),
  			gid: utils.pad(gid, 7),
  			fileSize: utils.pad(input.length, 11),
  			mtime: utils.pad(mtime, 11),
  			checksum: '        ',
  			type: '0', // just a file
  			ustar: 'ustar  ',
  			owner: opts.owner || '',
  			group: opts.group || ''
  		};
  
  		// calculate the checksum
  		checksum = 0;
  		Object.keys(data).forEach(function (key) {
  			var i, value = data[key], length;
  
  			for (i = 0, length = value.length; i < length; i += 1) {
  				checksum += value.charCodeAt(i);
  			}
  		});
  
  		data.checksum = utils.pad(checksum, 6) + "\u0000 ";
  
  		headerArr = header.format(data);
  
  		var i, offset, length;
  
  		this.out.set(headerArr, this.written);
  
  		this.written += headerArr.length;
  
  		// If there is not enough space in this.out, we need to expand it to
  		// fit the new input.
  		if (this.written + input.length > this.out.length) {
  			this.out = utils.extend(this.out, this.written, input.length, blockSize);
  		}
  
  		this.out.set(input, this.written);
  
  		// to the nearest multiple of recordSize
  		this.written += input.length + (recordSize - (input.length % recordSize || recordSize));
  
  		// make sure there's at least 2 empty records worth of extra space
  		if (this.out.length - this.written < recordSize * 2) {
  			this.out = utils.extend(this.out, this.written, recordSize * 2, blockSize);
  		}
  
  		if (typeof callback === 'function') {
  			callback(this.out);
  		}
  
  		return this.out;
  	};
  
  	Tar.prototype.clear = function () {
  		this.written = 0;
  		this.out = utils.clean(blockSize);
  	};
  	
  	module.exports = Tar;
  }());
  

  provide("tar-example/.lib/tar", module.exports);
  $.ender(module.exports);
}(global));

// ender:tar-example as tar-example
(function (context) {
  
  var module = { exports: {} }, exports = module.exports
    , $ = require("ender")
    ;
  
  
  (function () {
  	"use strict";
  
  	var Tar =  require('tar-example/.lib/tar'),
  		utils =  require('tar-example/.lib/utils'),
  		tape = new Tar(),
  		out,
  		url,
  		base64;
  
  	function uint8ToString(buf) {
  		var i, length, out = '';
  		for (i = 0, length = buf.length; i < length; i += 1) {
  			out += String.fromCharCode(buf[i]);
  		}
  
  		return out;
  	}
  
  	out = tape.append('output.txt', 'This is test1!');
  	out = tape.append('dir/out.txt', 'This is test2! I changed up the directory');
  	out = tape.append('arr.txt', utils.stringToUint8('This is a Uint8Array!'));
  
  	base64 = btoa(uint8ToString(out));
  
  	url = "data:application/tar;base64," + base64;
  	window.open(url);
  }());
  

  provide("tar-example", module.exports);
  $.ender(module.exports);
}(global));